unit MiniMapUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TMiniMapForm = class(TForm)
    Gid: TShape;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure GidMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GidMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GidMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    //FGidClicked : Boolean;
    dL,dT       : Integer; // Shifts from Gid.Left,Top

    procedure ScrollTo(Const X,Y : Integer);

  public
    MiniMapBitmap : TBitmap;
  end;

var
  MiniMapForm: TMiniMapForm;

implementation

uses Unit1;

{$R *.DFM}

procedure TMiniMapForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Action:=caHide;
Form1.MiniMap1.Checked:=false;
end;

procedure TMiniMapForm.FormCreate(Sender: TObject);
begin
 ClientHeight:=32;
 MiniMapBitmap:=TBitmap.Create;
 MiniMapBitmap.Width:=ClientWidth;
 MiniMapBitmap.Height:=ClientHeight;
 MiniMapBitmap.PixelFormat:=pf24bit;
end;

procedure TMiniMapForm.GidMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 //FGidClicked:=true;
 dL:=X;
 dT:=Y;
end;

procedure TMiniMapForm.GidMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//FGidClicked:=false;
end;

procedure TMiniMapForm.ScrollTo(const X, Y: Integer);
begin
//
end;

procedure TMiniMapForm.GidMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
Var
MouseX,MouseY : Integer;
CursorPos     : TPoint;
begin
if  ssLeft in Shift then
begin
 GetCursorPos(CursorPos);
 CursorPos:=ScreenToClient(CursorPos);
 Gid.Left:=CursorPos.x-dL;
 Gid.Top:=CursorPos.y-dT;
 if Gid.Left<0 then Gid.Left:=0;
 if Gid.Top<0 then Gid.Top:=0;

 if Gid.Left+Gid.Width>ClientWidth then Gid.Left:=ClientWidth-Gid.Width;
 if Gid.Top+Gid.Height>ClientHeight then Gid.Top:=ClientHeight-Gid.Height;

 Form1.dx:=Gid.Left*Form1.ChipW;
 Form1.dy:=Gid.Top*Form1.ChipH;
 Form1.Invalidate;

end;

end;

procedure TMiniMapForm.FormDestroy(Sender: TObject);
begin
 MiniMapBitmap.Free;
end;

procedure TMiniMapForm.FormPaint(Sender: TObject);
begin
 Canvas.Draw(0,0,MiniMapBitmap);
end;

procedure TMiniMapForm.FormResize(Sender: TObject);
begin
 if Not Assigned(MiniMapBitmap) then Exit;
 MiniMapBitmap.Width:=ClientWidth;
 MiniMapBitmap.Height:=ClientHeight;
 MiniMapBitmap.PixelFormat:=pf24bit;
end;

end.
