unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, ComCtrls, ToolWin, Menus, ExtCtrls, StdCtrls;

type
 TTileInf = record
    SetN     : byte;
    TileN    : byte;
    TileBits : byte;
   end;

  TMapSize=(msLarge,msMedium,msSmall,msExSmall);

Const
  MapSizeS: Array[0..3] of ShortString=('Large','Medium','Small','ExSmall');
  MapSizeN: Array[0..3] of integer=(128,96,64,32);

  DirX   : Array[0..7] of ShortInt=(-1, 0, 1, 0,-1, 1, 1,-1);
  DirY   : Array[0..7] of ShortInt=( 0,-1, 0, 1,-1,-1, 1, 1);

  //lDirX  : Array[0..15] of ShortInt=( 2,-2,-2,-1, 0, 1, 2, 2,2,2,2,1,0,-1,-2,-2);
  //lDirY  : Array[0..15] of ShortInt=( 0,-1,-2,-2,-2,-2,-2,-1,0,1,2,2,2, 2, 2, 1);

  MiniMapColor: Array[0..4] of TColor=(clBlue,clMaroon,clGreen,$00015003,clGray);

  MaskArr0 : Array[0..7]of byte=(145,50,100,200,179,118,236,217);
  //MaskArr0 : Array[0..7]of byte=(155,55,110,205,191,127,239,223);
  MaskArr1 : Array[0..7]of byte=(100,200,145,50,64,128,16,32);
  DirToBit : Array[0..7] of ShortInt=(2,3,0,1,6,7,4,5);

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    ImageList1: TImageList;
    Options1: TMenuItem;
    ShowGrid: TMenuItem;
    Show_TileInf: TMenuItem;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    Panel1: TPanel;
    Label1: TLabel;
    Panel2: TPanel;
    View1: TMenuItem;
    MiniMap1: TMenuItem;
    Help1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    MapSizeLabel: TLabel;
    Label2: TLabel;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ShowGridClick(Sender: TObject);
    procedure Show_TileInfClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure MiniMap1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
  private
    FMapSize : TMapSize;

    procedure InitTileMap(SetN,TileN,TileBits: byte);
    procedure PaintTile(i,j : integer);
    procedure SetTile(X, Y: Integer;AMapBrush : byte);
    //procedure InitTileTypeMap(TileType: byte);
    procedure CheckNeighbours(cnx,cny : integer);
    procedure Do3x3(cnx, cny: Integer; AMapBrush: byte);
    procedure Do1x1(cnx, cny: Integer; const AMapBrush: byte);
    procedure SetMapSize(const Value: TMapSize);
    procedure DoMain1x1(cnx, cny: Integer; const AMapBrush: byte);
    procedure SaveMap(FileName : string );
    procedure LoadMap(FileName: string);
    { Private declarations }
  public

    DimW,DimH           : Integer;
    ChipW,ChipH         : Integer;

    FTileMap            : Array of Array of TTileInf;
    //FTileTypeMap        : Array of Array of byte;

    FMapBrush           : Byte;

    Set1Bitmap          : TBitmap;
    Set2Bitmap          : TBitmap;
    Set3Bitmap          : TBitmap;

    dx0,dy0             : integer;
    ViewW,ViewH         : integer;

    dx,dy               : integer;

    //property MapSize : TMapSize read FMapSize write SetMapSize;
    property MapSize : TMapSize write SetMapSize;

  end;

var
  Form1: TForm1;

implementation
Uses
 Pathes, MiniMapUnit, NewUnit ;

{$R *.DFM}

{ ------------------------- }
{ ---  BIT MANIPULATION --- }
{ ------------------------- }
{ This function accepts a byte parameter and returns
  a string of eight ones and zeros indicating the
  binary form of a bite. }
function ShowBits(B : Byte): string;
var
  i: Integer;
  bt: Byte;
  s: string;
begin
  bt := $01;
  s := '';
  for i := 1 to 8 do begin
    if (b And bt) > 0 then
       S := '1' + s
    else
      s := '0' + s;
     {$R-}
      bt := bt shl 1;
     {$R+}
    end;
  ShowBits := s;
end;
{ This procedure sets a particular bit in the byte changebyte
  to either 1 or 0. The bit is specified by Position, which can range
  from 0 to 7. In Value, put 1 if you want the bit Position set to 1
  and put 0 if you want bit Position set to 0. The right byte is Position
  0, the far left is Position 7. Based on a routine found in
  Turbo Pascal by Stephen K O'Brian. }
procedure SetBit(Position : Integer; Value : Byte; var ChangeByte : Byte);
var
  Bt : Byte;
begin
  bt := $01;
  bt := bt shl Position;
  if Value = 1 then
    ChangeByte := ChangeByte or bt
  else begin
    bt := bt xor $FF;
    ChangeByte := ChangeByte and bt;
  end;
end;
{ This function tests if a bit in TestByte is turned on (equal to 1).
  If the bit indicated by Position is turned on, then BitOn returns True. }
function BitOn(Position : Integer; TestByte : Byte) : Boolean;
var
  bt : Byte;
begin
  bt := $01;
  bt := bt shl Position;
  BitOn := (bt and TestByte) > 0;
end;

function IsBitOn (Value: Byte; Bit: Byte): Boolean;
begin
  Result := (Value and (1 shl Bit)) <> 0;
end;

function TurnBitOn (Value: Byte; Bit: Byte): Integer;
begin
  Result := Value or (1 shl Bit);
end;

function TurnBitOff (Value: Byte; Bit: Byte): Integer;
begin
  Result := Value and not (1 shl Bit);
end;

{ ------------------------- }
{ -- STRING MANIPULATION -- }
{ ------------------------- }

function StripFromFront(S: string; Len: Integer): string;
Var
 Count : integer;
begin
 Count:=Length(S)-Len;
 Move(S[Len+1],S[1],Count);
 SetLength(S,Count);
 Result:=S;
end;

{ ----------------------------------------------------------------------- }
{ ----------------------------------------------------------------------- }

procedure TForm1.FormCreate(Sender: TObject);
begin
 SaveDialog.InitialDir:=GetName('Map');
 OpenDialog.InitialDir:=GetName('Map');

 Brush.Style:=bsClear;

 dx0:=0;
 dy0:=ControlBar1.Height;

 ViewW:=ClientWidth;
 ViewH:=ClientHeight;

 ChipW:=32;
 ChipH:=32;

 Set1Bitmap:=TBitmap.Create;
 Set2Bitmap:=TBitmap.Create;
 Set3Bitmap:=TBitmap.Create;

 Set1Bitmap.Loadfromfile(GetName('Graphics\bmp','Set1.bmp'));
 Set2Bitmap.Loadfromfile(GetName('Graphics\bmp','Set2.bmp'));
 Set3Bitmap.Loadfromfile(GetName('Graphics\bmp','Set3.bmp'));

 MiniMapForm:=TMiniMapForm.Create(Application);

 MapSize:=msExSmall;

 ToolButton2.Down:=true;
 ToolButton2.Click;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 Set1Bitmap.Free;
 Set2Bitmap.Free;
 Set3Bitmap.Free;

end;


{
procedure TForm1.InitTileTypeMap(TileType : byte );
Var
i,j : integer;
begin

For i:=0 to DimW-1 do
 For j:=0 to DimH-1 do
 begin
  FTileTypeMap[j,i]:=TileType;
 end;

end;
}

procedure TForm1.InitTileMap(SetN,TileN,TileBits : byte );
Var
i,j : integer;
begin
{
For i:=0 to DimW-1 do
 For j:=0 to DimH-1 do
 begin
  FTileTypeMap[j,i]:=SetN;
 end;
}

For i:=0 to DimW-1 do
 For j:=0 to DimH-1 do
 begin
  FTileMap[j,i].SetN:=SetN;
  FTileMap[j,i].TileN:=TileN;
  FTileMap[j,i].TileBits:=TileBits;
 end;

invalidate;

 MiniMapForm.MiniMapBitmap.Canvas.Brush.Color:=MiniMapColor[SetN];
 MiniMapForm.MiniMapBitmap.Canvas.FillRect(MiniMapForm.ClientRect);
 MiniMapForm.Invalidate;

end;


procedure TForm1.FormPaint(Sender: TObject);
Var
 i,j : integer;
begin
For i:=0 to DimW-1 do
 For j:=0 to DimH-1 do
 begin
  PaintTile(i,j);
 end;
end;

procedure TForm1.PaintTile(i,j : integer);
Var
 MapX,MapY   : Integer;
 X,Y         : Integer;
 SetN,TileN,TileBits : byte;
 STileRect   : TRect;
 DRect       : TRect;
 STileX,STileY : integer;
 S           : String;
 TmpBits     : BYTE;

 ClipRect    : TRect;

begin
  MapX:=i*ChipW;
  MapY:=j*ChipH;

  ClipRect:=Bounds(dx-ChipW,dy-ChipH,ViewW+2*ChipW,ViewH+2*ChipH);
  if Not PtInRect(ClipRect,Point(MapX,MapY)) then Exit;

  x:=MapX-dx;// in Form coord
  y:=MapY-dy;// in Form coord


  DRect:=Bounds(x,y,ChipW,ChipH);

  SetN:=FTileMap[j,i].SetN;
  TileN:=FTileMap[j,i].TileN;
  TileBits:=FTileMap[j,i].TileBits;

  MiniMapForm.MiniMapBitmap.Canvas.Pixels[i,j]:=MiniMapColor[SetN];
  MiniMapForm.Invalidate;

  if (SetN=0)and(TileBits=255) then
   begin
    SetN:=1;
    TileBits:=0;
    TileN:=16;
   end;

  STileX:=(TileN mod 16)*ChipW;
  STileY:=(TileN div 16)*ChipH;
  STileRect:=Bounds(STileX,STileY,ChipW,ChipH);


  Case SetN of
   1: Canvas.CopyRect(DRect,Set1Bitmap.Canvas,STileRect);
   2: Canvas.CopyRect(DRect,Set2Bitmap.Canvas,STileRect);
   3: Canvas.CopyRect(DRect,Set3Bitmap.Canvas,STileRect);
  end;


  Canvas.Brush.Style:=bsClear;
  Canvas.pen.Width:=1;
  Canvas.pen.Color:=clGreen;
  if ShowGrid.Checked
   then Canvas.Rectangle(x,y,x+ChipW+1,y+ChipH+1);

  if Show_TileInf.Checked then
   begin
    Canvas.Font.Size:=7;
    Canvas.Font.Color:=clGray;
    Canvas.Font.name:='Arial';

    //Canvas.TextOut(x,y,IntToStr(i)+','+IntToStr(j));
    //Canvas.TextOut(x,y,IntToStr(TileBits)+','+IntToStr(TileN));

    Canvas.TextOut(x,y,IntToStr(TileBits));

    S:=IntToStr(SetN);
    Canvas.TextOut(x+ChipW-8,y,S);


    TmpBits:=TileBits;
    TmpBits:=TmpBits and 15; // mask 00001111 extract lo bits
    S:=ShowBits(TmpBits);

    S:=StripFromFront(S,4);

    Canvas.TextOut(x,y+10,S);

    TmpBits:=TileBits;
    TmpBits:=TmpBits SHR 4; //extract hi bits
    S:=ShowBits(TmpBits);
    S:=StripFromFront(S,4);
    Canvas.TextOut(x,y+20,S);

   end;

end;


procedure TForm1.CheckNeighbours(cnx,cny : integer);
Var
 nx,ny       : integer;
 i           : integer;
 SetN, TileN, TileBits  : byte;
 cSetN, cTileN, cTileBits  : byte;
begin
 cTileBits:=FTileMap[cny,cnx].TileBits;
 cSetN:=FTileMap[cny,cnx].SetN;

 for i:=0 to 7 do
  begin
   nx:=cnx+DirX[i];
   ny:=cny+DirY[i];

   if (nx<0)or(ny<0)or(nx>DimW-1)or(ny>DimH-1)
    then continue;

   TileBits:=FTileMap[ny,nx].TileBits;
   SetN:=FTileMap[ny,nx].SetN;

   if SetN=cSetN then
   begin
   if BitOn(DirToBit[i],TileBits)
    then SetBit(i,1,cTileBits)
     else SetBit(i,0,cTileBits);
   end;

   if SetN<cSetN then
   begin
   if BitOn(DirToBit[i],TileBits)
    then SetBit(i,0,cTileBits);
   end;

   if SetN>cSetN then
   begin
   if  NOT BitOn(DirToBit[i],TileBits)
    then SetBit(i,1,cTileBits);
   end;

 end;//i

 if ((cTileBits and 5)=5) or //bits 0&2 = 1
    ((cTileBits and 10)=10)  //bits 1&3 = 1
  then cTileBits:=255;       //all bits = 1

 if ((cTileBits and 48)=48) then SetBit(1,1,cTileBits); //bit 1=1
 if ((cTileBits and 96)=96) then SetBit(2,1,cTileBits); //bit 2=1
 if ((cTileBits and 192)=192) then SetBit(3,1,cTileBits); //bit 3=1
 if ((cTileBits and 144)=144) then SetBit(0,1,cTileBits); //bit 0=1



 if cTileBits=0 then
  begin
   cTileBits:=255;
   dec(cSetN);
   FTileMap[cny,cnx].SetN:=cSetN;
  end;


 FTileMap[cny,cnx].TileBits:=cTileBits;

end;


procedure TForm1.SetTile(x,y : Longint; AMapBrush : byte);
Var
 MapX,MapY   : Integer;
 cnx,cny : integer;
begin
 x:=x+dx;// x to MapX
 y:=y+dy;// y to MapY

 cnx:=x div ChipW;
 cny:=y div ChipH;

 if (cnx<DimW)and(cny<DimH)
  then Do1x1(cnx,cny,AMapBrush);
end;

procedure TForm1.Do1x1(cnx,cny : Longint; const AMapBrush : byte );
Var
 nx,ny                     : integer;
 i,j                       : integer;
 SetN,   TileN,  TileBits  : byte;
 cSetN, cTileN, cTileBits  : byte;
 TmpBits                   : byte;
begin
cSetN:=FTileMap[cny,cnx].SetN;


if AMapBrush-cSetN<=-2 then
 begin
  Do1x1(cnx,cny,AMapBrush+1);
  Do1x1(cnx,cny,AMapBrush);
  Exit;
 end;


if AMapBrush-cSetN>=2 then
 begin
  Do1x1(cnx,cny,AMapBrush-1);
  Do1x1(cnx,cny,AMapBrush);
  Exit;
 end;


if(AMapBrush-cSetN=0) or
  (AMapBrush-cSetN=1) or
  (AMapBrush-cSetN=-1)then
begin
{
cSetN:=AMapBrush;
cTileN:=15;
cTileBits:=255;

FTileMap[cny,cnx].SetN:=cSetN;
FTileMap[cny,cnx].TileN:=cTileN;
FTileMap[cny,cnx].TileBits:=cTileBits;
}
for i:=0 to 7 do //set neighbours to correct tile
 begin
  nx:=cnx+DirX[i];
  ny:=cny+DirY[i];

  if (nx<0)or(ny<0)or(nx>DimW-1)or(ny>DimH-1)
    then continue;

  SetN:=FTileMap[ny,nx].SetN;
  TileN:=FTileMap[ny,nx].TileN;
  TileBits:=FTileMap[ny,nx].TileBits;

  if (AMapBrush-SetN=1)and(TileBits<255)then
  begin
   Do1x1(nx,ny,AMapBrush-1);
  end;


  if (AMapBrush-SetN=-2)then
  begin
   Do1x1(nx,ny,AMapBrush+1);
  end;


 end;

 DoMain1x1(cnx,cny,AMapBrush);//when neighbours is correct

 Exit;
end;



cSetN:=FTileMap[cny,cnx].SetN;
if AMapBrush-cSetN<=-2 then
 begin
  Do1x1(cnx,cny,AMapBrush+1);
  {
  for i:=0 to 7 do
   begin
    nx:=cnx+DirX[i];
    ny:=cny+DirY[i];
    if (nx<0)or(ny<0) then continue;

    SetN:=FTileMap[ny,nx].SetN;
    if AMapBrush-SetN<=-2 then
     begin
      Do1x1(nx,ny,AMapBrush+1);
     end;
   end;

  Do1x1(cnx,cny,AMapBrush);
  }
  //Exit;
 end;



if AMapBrush-cSetN>=2 then
 begin
  //Do1x1(cnx,cny,AMapBrush-1);
  //Do3x3(cnx,cny,AMapBrush-1); // :(


  for i:=0 to 7 do
   begin
    nx:=cnx+DirX[i];
    ny:=cny+DirY[i];
    if (nx<0)or(ny<0) then continue;

    SetN:=FTileMap[ny,nx].SetN;
    TileBits:=FTileMap[ny,nx].TileBits;
    if (AMapBrush-SetN>=2)or
       ( (AMapBrush-SetN=1)and(TileBits<255 ) )
     then
     begin
      Do1x1(nx,ny,AMapBrush-1);
     end;
   end;

  Do1x1(cnx,cny,AMapBrush);

  //Exit;

 end;



  if AMapBrush-SetN<=-2 then
  begin
   Do1x1(nx,ny,AMapBrush+1);
   SetN:=FTileMap[ny,nx].SetN;
  end;

  if AMapBrush-SetN>=2 then
  begin
   Do1x1(nx,ny,AMapBrush-1);
   //Do3x3(cnx,cny,AMapBrush-1); // :(
   SetN:=FTileMap[ny,nx].SetN;
  end;

end;

procedure TForm1.DoMain1x1(cnx,cny : Longint; const AMapBrush : byte );
Var
 nx,ny                     : integer;
 i,j                       : integer;
 SetN,   TileN,  TileBits  : byte;
 cSetN, cTileN, cTileBits  : byte;
 TmpBits                   : byte;
begin

cSetN:=AMapBrush;
cTileN:=15;
cTileBits:=255;

FTileMap[cny,cnx].SetN:=cSetN;
FTileMap[cny,cnx].TileN:=cTileN;
FTileMap[cny,cnx].TileBits:=cTileBits;

PaintTile(cnx,cny);

for i:=0 to 7 do
 begin
  nx:=cnx+DirX[i];
  ny:=cny+DirY[i];

  if (nx<0)or(ny<0)or(nx>DimW-1)or(ny>DimH-1)
    then continue;

  SetN:=FTileMap[ny,nx].SetN;
  TileN:=FTileMap[ny,nx].TileN;
  TileBits:=FTileMap[ny,nx].TileBits;


  if (AMapBrush-SetN=0)or(AMapBrush-SetN=1)then
  //if (AMapBrush-SetN=0)or( (AMapBrush-SetN=1)and(TileBits=255) )then
  begin
   TileBits:=0;
   FTileMap[ny,nx].SetN:=AMapBrush;// i.e. = cSetN;
   TileBits:=TileBits or MaskArr1[i];// draw by Bit=1
  end;

  {
  if (AMapBrush-SetN=1)and(TileBits<255)then
  begin
   continue;
  end;
  }

  if AMapBrush-SetN=-1 then
  begin
   //FTileMap[ny,nx].SetN:=FBrushTileType;// i.e. = cSetN;
   TileBits:=FTileMap[ny,nx].TileBits;
   TileBits:=TileBits and  MaskArr0[i];//draw by Bit=0
  end;

  FTileMap[ny,nx].TileBits:=TileBits;//Set TileInt

end;


for i:=0 to 7 do // repeat cycle to check neighbours
 begin
  nx:=cnx+DirX[i];
  ny:=cny+DirY[i];

  if (nx<0)or(ny<0)or(nx>DimW-1)or(ny>DimH-1)
    then continue;

  CheckNeighbours(nx,ny);

  TileBits:=FTileMap[ny,nx].TileBits;//Get TileInt for calc TileN
  TmpBits:=TileBits;
  TmpBits:=TmpBits and 15; // mask 00001111 extract lo bits
  if (TmpBits<16)and(TmpBits>0)
   then TileN:=TmpBits
    else TileN:=16 + TileBits SHR 4; //extract hi bits
  FTileMap[ny,nx].TileN:=TileN;

  PaintTile(nx,ny);

end;

end;


procedure TForm1.Do3x3(cnx,cny : Longint;AMapBrush : byte );
Var
 nx,ny : integer;
 i     : integer;
begin
Do1x1(cnx,cny,AMapBrush);
for i:=0 to 7 do
 begin
  nx:=cnx+DirX[i];
  ny:=cny+DirY[i];
  if (nx<0)or(ny<0) then continue;
  Do1x1(nx,ny,AMapBrush);
 end;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
 FMapBrush:= (Sender as TToolButton).tag;
 Label1.Caption:='MapBrush = '+IntToStr(FMapBrush);
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 //SetTile(X-dx0,Y-dy0,FMapBrush);
 SetTile(X,Y,FMapBrush);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
 //Label2.Caption:=IntToStr(X-dx0)+' '+IntToStr(Y-dy0);
 //if ssLeft In Shift then SetTile(X-dx0,Y-dy0,FMapBrush);
 if ssLeft In Shift then SetTile(X,Y,FMapBrush);
end;

procedure TForm1.ShowGridClick(Sender: TObject);
begin
ShowGrid.Checked:=not ShowGrid.Checked;
invalidate;
end;

procedure TForm1.Show_TileInfClick(Sender: TObject);
begin
Show_TileInf.Checked:=not Show_TileInf.Checked;
invalidate;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.MiniMap1Click(Sender: TObject);
begin
 MiniMap1.Checked:=not MiniMap1.Checked;
 MiniMapForm.Visible:=MiniMap1.Checked;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
if not Assigned(NewForm)
 then Application.CreateForm(TNewForm,NewForm);

NewForm.FormStyle:=fsStayOnTop;
NewForm.Show;

end;

procedure TForm1.SetMapSize(const Value: TMapSize);
Var
S         : string;
NX,NY     : Integer;
ABrushMap : byte;
begin
  //FMapSize := Value;// not Used

  DimW:=MapSizeN[Ord(Value)];
  DimH:=DimW;

  MapSizeLabel.Caption:='MapSize = '+MapSizeS[Ord(Value)]+' ('+IntToStr(DimW)+'x'+IntToStr(DimH)+')';


  FTileMap:=nil;
  SetLength(FTileMap,DimH,DimW);

  //SetLength(FTileTypeMap,DimH,DimW);

  ABrushMap:=2;
  Case ABrushMap of
   //0 : InitTileMap(1,16,255);
   1 : InitTileMap(1,15,255);
   2 : InitTileMap(2,15,255);
   3 : InitTileMap(3,15,255);
  end;

  MiniMapForm.ClientWidth:=DimW;
  MiniMapForm.ClientHeight:=DimH;

  MiniMapForm.Gid.Left:=0;
  MiniMapForm.Gid.Top:=0;
  dx:=0;
  dy:=0;

  MiniMapForm.Gid.Width:=ViewW div ChipW;
  MiniMapForm.Gid.Height:=ViewH div ChipH;

end;

procedure TForm1.FormResize(Sender: TObject);
begin
 ViewW:=ClientWidth;
 ViewH:=ClientHeight;
end;

procedure TForm1.SaveMap(FileName: string);
Var
i,j : integer;
fs  : TFileStream;
bVal: byte;
begin
fs:=TFileStream.Create(FileName,fmCreate);
try

fs.Write(DimH,sizeof(DimH));
fs.Write(DimW,sizeof(DimW));

For i:=0 to DimW-1 do
 For j:=0 to DimH-1 do
 begin
  bval:=FTileMap[j,i].SetN;
  fs.Write(bval,sizeof(bval));

  bval:=FTileMap[j,i].TileN;
  fs.Write(bval,sizeof(bval));

  bval:=FTileMap[j,i].TileBits;
  fs.Write(bval,sizeof(bval));

 end;
finally
fs.Free;
end;

end;

procedure TForm1.LoadMap(FileName: string);
Var
 i,j : integer;
 fs  : TFileStream;
 bVal: byte;
begin

fs:=TFileStream.Create(FileName,fmOpenRead);
try

fs.Read(DimH,sizeof(DimH));
fs.Read(DimW,sizeof(DimW));

MapSizeLabel.Caption:='MapSize = '+'('+IntToStr(DimW)+'x'+IntToStr(DimH)+')';


  FTileMap:=nil;
  SetLength(FTileMap,DimH,DimW);

  MiniMapForm.ClientWidth:=DimW;
  MiniMapForm.ClientHeight:=DimH;

  MiniMapForm.Gid.Left:=0;
  MiniMapForm.Gid.Top:=0;
  dx:=0;
  dy:=0;

  MiniMapForm.Gid.Width:=ViewW div ChipW;
  MiniMapForm.Gid.Height:=ViewH div ChipH;


For i:=0 to DimW-1 do
 For j:=0 to DimH-1 do
 begin
  fs.Read(bval,sizeof(bval));
  FTileMap[j,i].SetN:=bval;

  fs.Read(bval,sizeof(bval));
  FTileMap[j,i].TileN:=bval;

  fs.Read(bval,sizeof(bval));
  FTileMap[j,i].TileBits:=bval;
 end;

invalidate;

finally
fs.Free;
end;

end;

procedure TForm1.Open1Click(Sender: TObject);
begin
if OpenDialog.Execute
 then LoadMap(OpenDialog.FileName);
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
if SaveDialog.Execute
 then SaveMap(SaveDialog.FileName);
end;

end.


